/* DBToolSingleton1 a Utility class
 * Copyright 2011 Michael Claudius, Inc. All Rights Reserved.
 * Version 1.0 2011.04.26
 * All rights reserved
 */
package dbtoolkit;

import java.sql.*;

public class DBToolSingleton1 {

// If You only want one stmt through the whole execution time you can also use this
    //private static Connection con = DBToolSingleton.getConnection();
    //private static Statement stmt = DBToolSingleton.getStatement();
    private static Connection con = null;
    private static Statement stmt = null;
    private static String login, passwd, url, driverClass;
    private static DBToolSingleton1 singleton = new DBToolSingleton1();

    // Establish connection and statement
    private DBToolSingleton1() {
    }

    private static void connect() {
        //Alternatively set up pr0perties here or read from file
        login = "root";
        passwd = "MikiYu";
        url = "jdbc:mysql://localhost:3306/testHotel"; //data source
        driverClass = "com.mysql.jdbc.Driver";
        
        try {
            Class.forName(driverClass);
            con = DriverManager.getConnection(url, login, passwd);
            stmt = con.createStatement();
        } catch (java.lang.ClassNotFoundException ex) {
            System.err.print("ClassNotFoundException: ");
            System.err.println(ex.getMessage());
        } catch (SQLException ex) {
            System.err.print("Connection refused: ");
            System.err.println(ex.getMessage());
            close();
        }
    }

    public static DBToolSingleton1 getSingleton() {
        return singleton;
    }

    public static Statement getStatement() {
        if (stmt == null) connect();
        return stmt;
    }

    public static Connection getConnection() {
        if (con == null) connect();
        return con;
    }

    // Close connection and statement
    public static void close() {
        try {
            if (stmt != null) {
                stmt.close();
            }
            if (con != null) {
                con.close();
            }
        } catch (SQLException ex) {
            System.err.println(ex.getMessage());
        }
    }

    public static void main(String args[]) throws SQLException {
        //DBToolSingleton dbt = DBToolSingleton.getSingleton();
        Connection con = DBToolSingleton1.getConnection();
        Statement stmt = con.createStatement();
        //Or just write
        //Statement stmt = DBToolSingleton.getStatement();
        String sqlQuery = "select * from guest";
        ResultSet rs = stmt.executeQuery(sqlQuery);
        ResultSetMetaData rsMeta = rs.getMetaData();

        int colNo = rsMeta.getColumnCount();
        String colNames = "\t";
        for (int i = 1; i <= colNo; i++) {
            colNames = colNames + rsMeta.getColumnLabel(i) + "\t";
        }
        System.out.println("columns:" + colNames);

        while (rs.next()) {
            String record = "\t";
            for (int i = 1; i <= colNo; i++) {
                record = record + rs.getString(i) + "\t";
            }
            System.out.println("record: " + record);
        }

        DBToolSingleton1.close();

    }
}// DBToolSingleton

